#ifndef __HTH_RULE_H__
#define __HTH_RULE_H__

/* the encoding of the game board
 *
 *   the red player
 * (8, 0){72}    ...       ...  (8, 8){80}
 *   ...                          ...
 * (1, 0){ 9}                     ...
 * (0. 0){ 0}  (0, 1){ 1}  ...  (0, 8){ 8}
 *   the blue player
 */
/* state is an array of int
 * [0] -- [8]: the position of blue pieces
 * [9] -- [17]: the position of red pieces
 * [18] -- [98]: [N] is the piece in the grid {N - 18}
 *               -1: the grid is empty
 *               -2: the piece here has been captured
 * [99]: the number of blue pieces
 * [100]: the number of red pieces
 */
#define STATE_SIZE 101

int state_reset(int *state);
int state_is_sane(int *state);
int move_is_legal(int *state, int turn_player, int grid_from, int grid_to,
                  int victory_condition);
int move_piece(int *state, int grid_from, int grid_to);
int capture_piece(int *state, int grid_to);
int remove_corpse(int *state);
int count_piece(int *state, int *num_blue, int *num_red);

#endif /* not __HTH_RULE_H__ */
